<?php
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */

//Import file to generate client token
require_once('getClientToken.php');
//$clientToken = Braintree_ClientToken::generate();
?>

<!DOCTYPE html>
<html>
<head>
<title>BT Dropin Template</title>
      <!--Let browser know website is optimized for mobile-->
      <meta name="viewport" content="width=device-width, initial-scale=1.0"/>     
</head>
<body>
	<div>
	        <div>
	      	  <img width="250" src="https://sickr.files.wordpress.com/2012/03/steam_logo1.png"><textarea style="width:200px; height:200px;" id="textarea1" disabled> Steam account, one time account creation fee and then you can choose to buy 1 of 100's of titles at discount prices </textarea>
	        </div>
		<br>
	        <div>
	          <input disabled value="10" id="price" type="text">
	          <label for="price">Price</label>
	        </div>
		<br><br>
	  		<div id="dropin-container"></div>
	  		<button id="submit-button">Pay Now</button>
	  		<button id="google-pay-button">Google Pay</button>
	  		<div>
              <input type="checkbox" id="vault" name="vault">
              <label for="vault">Save your Card</label>
            </div>
	</div>
  
  	  <script src="https://js.braintreegateway.com/web/dropin/1.22.0/js/dropin.min.js"></script>
  	  <script src="https://js.braintreegateway.com/web/3.57.0/js/client.min.js"></script>
  	  
  	  <!--Import jQuery-->
      <script type="text/javascript" src="https://code.jquery.com/jquery-3.2.1.min.js"></script>
      
      <!--       Import the Google Libraries -->
      <script src="https://pay.google.com/gp/p/js/pay.js"></script>  
      <script src="https://js.braintreegateway.com/web/3.57.0/js/google-payment.min.js"></script>
      <script src='https://js.braintreegateway.com/web/3.57.0/js/three-d-secure.min.js'></script>
  

  
  <script type="text/javascript">

		//Reset vault value checkbox
  		document.getElementById('vault').checked = false;

	// Make sure to have https://pay.google.com/gp/p/js/pay.js loaded on your page

	// You will need a button element on your page styled according to Google's brand guidelines
	// https://developers.google.com/pay/api/web/guides/brand-guidelines
	var google_button = document.querySelector('#google-pay-button');
	var paymentsClient = new google.payments.api.PaymentsClient({
	  environment: 'TEST' // Or 'PRODUCTION'
	});
	
 	var threeDSecure;

	

	braintree.client.create({
	  authorization: '<?=$clientToken ?>'
	}, function (clientErr, clientInstance) {
		braintree.threeDSecure.create({
		    version: 2, // Will use 3DS 2 whenever possible
		    client: clientInstance
		  }, function (threeDSecureErr, threeDSecureInstance) {
		    if (threeDSecureErr) {
		      // Handle error in 3D Secure component creation
		      console.log("HERE");
		      return;
		    }

		    threeDSecure = threeDSecureInstance;
		  });
	  braintree.googlePayment.create({
	    client: clientInstance,
	    googlePayVersion: 2,
	    googleMerchantId: 'merchant-id-from-google' // Optional in sandbox; if set in sandbox, this value must be a valid production Google Merchant ID
	  }, function (googlePaymentErr, googlePaymentInstance) {
	    paymentsClient.isReadyToPay({
	      // see https://developers.google.com/pay/api/web/reference/object#IsReadyToPayRequest
	      apiVersion: 2,
	      apiVersionMinor: 0,
	      allowedPaymentMethods: googlePaymentInstance.createPaymentDataRequest().allowedPaymentMethods,
	      existingPaymentMethodRequired: true // Optional
	    }).then(function(response) {
	      if (response.result) {
	    	  google_button.addEventListener('click', function (event) {
	          event.preventDefault();

	          console.log(googlePaymentInstance.createPaymentDataRequest().allowedPaymentMethods);

	          var paymentDataRequest = googlePaymentInstance.createPaymentDataRequest({
	            transactionInfo: {
	              currencyCode: 'GBP',
	              totalPriceStatus: 'FINAL',
	              totalPrice: '5.00' // Your amount
	            }
	          });

	          // We recommend collecting billing address information, at minimum
	          // billing postal code, and passing that billing postal code with all
	          // Google Pay card transactions as a best practice.
	          // See all available options at https://developers.google.com/pay/api/web/reference/object
	          var cardPaymentMethod = paymentDataRequest.allowedPaymentMethods[0];
	          cardPaymentMethod.parameters.billingAddressRequired = true;
	          cardPaymentMethod.parameters.billingAddressParameters = {
	            format: 'FULL',
	            phoneNumberRequired: true
	          };

// 	          cardPaymentMethod.parameters.cardParameters = {
// 	        		  allowedAuthMethods: 'CRYPTOGRAM_3DS'
// 	  	          };

	          paymentsClient.loadPaymentData(paymentDataRequest).then(function(paymentData) {
	            googlePaymentInstance.parseResponse(paymentData, function (err, result) {
	              if (err) {
	                // Handle parsing error
		                alert("Parsing Error, Please try again");
	              }

	              // Send result.nonce to your server
	              // result.type may be either "AndroidPayCard" or "PayPalAccount", and
	              // paymentData will contain the billingAddress for card payments
	              var googleNonce = result.nonce;
	              console.log(result);
	              console.log("Nonce is " + googleNonce);
	              console.log("None tokenized?:" + result.details.isNetworkTokenized);
	              
	              if (result.details.isNetworkTokenized === false) {

		              console.log("Got inside isNetworkTokanized");
                      // eligible for 3DS Verification
	            	  threeDSecure.verifyCard({
	            			  amount: '5.00',
	            			  nonce: googleNonce, // Use Google Pay nonce
	            			  email: 'test@example.com',
	            			  billingAddress: {
	            				    givenName: 'Jill', // ASCII-printable characters required, else will throw a validation error
	            				    surname: 'Doe', // ASCII-printable characters required, else will throw a validation error
	            				    phoneNumber: '8101234567',
	            				    streetAddress: '555 Smith St.',
	            				    extendedAddress: '#5',
	            				    locality: 'Oakland',
	            				    region: 'CA',
	            				    postalCode: '12345',
	            				    countryCodeAlpha2: 'US'
	            				  },
	            				  additionalInformation: {
	            				    workPhoneNumber: '8101234567',
	            				    shippingGivenName: 'Jill',
	            				    shippingSurname: 'Doe',
	            				    shippingPhone: '8101234567',
	            				    shippingAddress: {
	            				      streetAddress: '555 Smith St.',
	            				      extendedAddress: '#5',
	            				      locality: 'Oakland',
	            				      region: 'CA',
	            				      postalCode: '12345',
	            				      countryCodeAlpha2: 'US'
	            				    }
	            				  },
	            			  onLookupComplete: function (data, next) {
		            			  console.log("Entered Lookup");
		            			  console.log("Data " + data);
	            			    next();
	            			  }

	            	  }, function (err, response) { 
	                      // Handle response 
	                      alert(JSON.stringify(response)); 
	                      console.log('3DS enriched payload: ' + JSON.stringify(response)); 
	                      
	                      console.log('3DS error: ' + JSON.stringify(err));


	                      // Submit payload.nonce to your server
	     	             var vars = {'payment_method_nonce' : response.nonce, 'vault':document.getElementById('vault').checked};
	     	             console.log(vars);
	     	             var myJSON = JSON.stringify(vars);

	     	              $.ajax({ 
	     		              	type: "POST",
	     		                  cache: false,
	     		            	    url: "doPayment.php",
	     		            	    dataType: "json",
	     		            	    data: myJSON
	     		            	}).done(function (data) {
	     		                	console.log(data);
	     		                	
	     		                	//vars = JSON.parse(data);
	     		                	if(data['success'] == 1)
	     		                	{
	     		                    	alert("Success");
	     		                	}
	     		                	else
	     		                	{
	     		                    	alert("Failed");
	     		                	}
	     		                	 console.log("Nonce return data: " + JSON.stringify(vars));
	     		            	}).fail(function (jqXHR, textStatus) {
	     		            	    console.log("failed to get nonce return data");
	     		            	});

	   		            	
	            			});

	            	  
                    }
                    	              
	              
	            

	            	
	            });
	          }).catch(function (err) {
	            // Handle errors
		        alert("An Error Occurred, Please Try Again");
		        console.log(err);
	          });
	        });
	      }
	    }).catch(function (err) {
	      // Handle errors
	    	alert("An Error Occurred, Please Try Again");
	    });
	  });

	  


	  
		// Set up other Braintree components
		var ppFlow;
		
		if(document.getElementById('vault').checked)
      	{
	       ppFlow = {flow: 'vault'};
	       
      	}
		else
		{
			ppFlow = {flow: 'checkout', amount: '10.00', currency: 'GBP'};
		}

		console.log(ppFlow);

		
	
	  var button = document.querySelector('#submit-button');

	    braintree.dropin.create({
	      authorization: '<?=$clientToken ?>',
	      container: '#dropin-container',
	      paypal: {
	    	    ppFlow
	    	  }
	    }, function (createErr, instance) {
	      button.addEventListener('click', function () {
	        instance.requestPaymentMethod(function (err, payload) {

	        	console.log(ppFlow);
	            
	          	 // Submit payload.nonce to your server
	             var vars = {'payment_method_nonce' : payload.nonce, 'vault':document.getElementById('vault').checked};
	             console.log(vars);
	             var myJSON = JSON.stringify(vars);

	             
	                $.ajax({ 
	              	type: "POST",
	                  cache: false,
	            	    url: "doPayment.php",
	            	    dataType: "JSON",
	            	    data: myJSON
	            	}).done(function (data) {
	                	console.log(data);
	                	
	                	//vars = JSON.parse(data);
	                	if(data['success'] == 1)
	                	{
	                    	alert("Success");
	                	}
	                	else
	                	{
	                    	alert("Failed");
	                	}
	                	 console.log("Nonce return data: " + vars);
	            	}).fail(function (jqXHR, textStatus) {
	            	    console.log("failed to get nonce return data");
	            	});
	        });
	      });
	    });

	    
	});
  </script>
  
  
	</body>
</html>  